
#include <bur/plctypes.h>

#ifdef _DEFAULT_INCLUDES
	#include <AsDefault.h>
#endif

#include "string.h"

void FunResetAxisCmd();

#define	STEP_INIT_NET_INIT			10
#define	STEP_INIT_POWER_OFF			20
#define	STEP_INIT_POWER_ON			25
#define	STEP_INIT_GLOBAL_INIT		30
#define	STEP_INIT_HOMING_DIRECT		40
#define	STEP_COMMAND				50
#define	STEP_SWITCH_OFF				60
#define	STEP_SWITCH_ON				70
#define	STEP_STOP_MOVE				80
#define	STEP_POS_MOVE				90
#define	STEP_NEG_MOVE				100
#define	STEP_ABS_MOVE				130
#define	STEP_REL_MOVE				140
#define	STEP_HOME					150
#define	STEP_TRIGGER_STOP			160
#define	STEP_CAM_START				170
#define	STEP_NOT_USE				180

#define	STEP_ERROR_HANDLE			900			/*裬֮*/
#define	STEP_ERROR_FUN				910			/*裬֮*/
#define	STEP_ERROR_AXIS				920			/*裬֮*/
#define	STEP_ERROR_RESET			930			/*裬֮*/


void _INIT ProgramInit(void)
{
	initOK = 0;
	for(i = 0; i < MULTI_AXIS_NUM; i ++)
	{
		/******************************************ȡʵָ********************************/
		ncStatus[i] = ncaccess(ncACP10MAN, (STRING*)MULTI_AXIS_NAME[i], &axisObj[i]);
		
		if ( (ncStatus[i] != ncOK) && (ncStatus[i] != 10600) )
		{
			/* The NC object pointer is invalid */
			gMultiAxis[i].alarm.errorNumber = ncStatus[i];
			strcpy(gMultiAxis[i].alarm.errorText[0], "Error to access name in NC-Deployment-Table");
			return;
		}
		/**************ʵָѾȫֱҲԴȫֱȡ*************************/
		
		/*˶ʼ*/
		gMultiAxis[i].para.velocity		= 3000;
		gMultiAxis[i].para.acceleration	= 5000;
		gMultiAxis[i].para.deceleration	= 5000;
		gMultiAxis[i].para.stopDeceleration	= 10000;
		gMultiAxis[i].para.absPosition	= 0;
		gMultiAxis[i].para.relPosition	= 0;
		gMultiAxis[i].para.homeAcce     = 10000;
		gMultiAxis[i].para.homeSpeed    = 2000;
		/*stepλ*/
		step[i] = STEP_INIT_NET_INIT;
	}
	initOK = 1;	
}

void _CYCLIC ProgramCyclic(void)
{
	if (initOK == 0) return;  //ʼ

	for (i = 0; i < MULTI_AXIS_NUM; i++)
	{
		/* Get the pointer of NC manager structure */
		pAxisData = (ACP10AXIS_typ*)axisObj[i];
		if(pAxisData == 0)	return;
		
		pWatchAxisData = (ACP10AXIS_typ*)axisObj[watchAxisIndex];				/*ʹ*/
		
		/****************Get axis status****************/
		gMultiAxis[i].status.actVelocity = pAxisData->monitor.v;
		gMultiAxis[i].status.actPosition = pAxisData->monitor.s;
		gMultiAxis[i].status.moveMode	 = pAxisData->move.mode;
		gMultiAxis[i].status.ctrlReady	 = pAxisData->controller.status;
		gMultiAxis[i].status.homeReady	 = pAxisData->move.homing.status.ok;
		gMultiAxis[i].status.inPosition	 = pAxisData->move.basis.status.in_pos;
		gMultiAxis[i].status.step		 = step[i];
		
		/****************Read axis error****************/
		MC_ReadAxisError_0[i].Axis = (UDINT)pAxisData;
		MC_ReadAxisError_0[i].Enable = !MC_ReadAxisError_0[i].Error;
		MC_ReadAxisError_0[i].DataAddress = (UDINT)&(gMultiAxis[i].alarm.errorText);
		MC_ReadAxisError_0[i].DataLength = sizeof(gMultiAxis[i].alarm.errorText);
		strcpy((void*)&MC_ReadAxisError_0[i].DataObjectName,"acp10etxen");
		MC_ReadAxisError(&MC_ReadAxisError_0[i]);
		
		/************************ ѭͨѶȡ ޸*************************/
		MC_BR_CyclicRead_0[i].Enable 		= !MC_BR_CyclicRead_0[i].Error;
		MC_BR_CyclicRead_0[i].ParID  		= ACP10PAR_ENCOD1_S_ACT;
		MC_BR_CyclicRead_0[i].DataAddress	= (UDINT)&cycReadPos[i];
		MC_BR_CyclicRead_0[i].DataType		= ncPAR_TYP_DINT;

		MC_BR_CyclicRead_0[i].Axis 			= (UDINT)pAxisData;
		MC_BR_CyclicRead(&MC_BR_CyclicRead_0[i]);  
		
		/*****************Read status******************/
		MC_ReadStatus_0[i].Axis = (UDINT)pAxisData;
		MC_ReadStatus_0[i].Enable = !MC_ReadStatus_0[i].Error;
		MC_ReadStatus(&MC_ReadStatus_0[i]);
		if(MC_ReadStatus_0[i].ContinuousMotion == 1 || MC_ReadStatus_0[i].Disabled == 1 || MC_ReadStatus_0[i].DiscreteMotion == 1 || MC_ReadStatus_0[i].Errorstop == 1 
			|| MC_ReadStatus_0[i].Homing == 1 || MC_ReadStatus_0[i].StandStill == 1 || MC_ReadStatus_0[i].Stopping == 1 || MC_ReadStatus_0[i].SynchronizedMotion == 1)
		{
			axisStatusReady[i] = 1;
			/*Ӵ˲ԭǷиϵMC_ReadStatusóɹһСʱ״̬0ڴʱڵκplcOpenɱ*/
		}
		else
		{
			axisStatusReady[i] = 0;
		}
		/***********************************************ȫᱨ*****************************************/
		if (MC_ReadAxisError_0[i].AxisErrorCount > 0 && MC_ReadAxisError_0[i].Valid == 1 && step[i] < STEP_ERROR_HANDLE)
		{
			step[i] = STEP_ERROR_HANDLE;	/*ᱨֱת*/
		}
		/**********************************************************************************************************/
		
		/***State sequence for handling the NC Object***/
		switch (step[i])
		{
			/* Wait until the network is initialized */
			case STEP_INIT_NET_INIT:											/*ȴʼ - һplcOpenҲҪ*/
				if (pAxisData->network.init == ncTRUE && axisStatusReady[i] == 1)
				{
					step[i] = STEP_INIT_POWER_OFF;
				}
				break;
			case STEP_INIT_POWER_OFF:											/*power off*/
				/*нӿλ*//*plcOpenִܿλ*/
				FunResetAxisCmd();
				/*Excute PLCOpen Function*/
				MC_Power_0[i].Enable = 0;
				if (MC_Power_0[i].Status == 0)									/*ɻж CommandAborted ڴ˴*/
				{
					step[i] = STEP_INIT_GLOBAL_INIT;							/*Ҫת*//*STEP_INIT_GLOBAL_INIT*//**//*STEP_COMMAND*/
				}
				if (MC_Power_0[i].Error == 1)									/**/	
				{
					gMultiAxis[i].alarm.errorNumber = MC_Power_0[i].ErrorID;	/*湦ܿ*/
					MC_Power_0[i].Enable = 0;									/*ܿ鸴λ λܿ*/
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Global initialization */
			case STEP_INIT_GLOBAL_INIT:											/*޸ʼеôҪִ  */
				/*Excute PLCOpen Function*/
				MC_BR_InitAxisPar_0[i].Execute = 1;
				if (MC_BR_InitAxisPar_0[i].Done == 1)
				{
					MC_BR_InitAxisPar_0[i].Execute = 0;
					step[i] = STEP_INIT_HOMING_DIRECT;
				}
				if (MC_BR_InitAxisPar_0[i].Error == 1 )
				{
					MC_BR_InitAxisPar_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_BR_InitAxisPar_0[i].ErrorID;
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Start homing procedure ѡǷִһ*/
			case STEP_INIT_HOMING_DIRECT:
				if (pAxisData->move.homing.status.ok == 1)
				{
					MC_Home_0[i].Execute = 0;
					step[i] = STEP_INIT_POWER_ON;
					break;
				}
				/*Excute PLCOpen Function*/
				MC_Home_0[i].HomingMode = ncDIRECT;
				MC_Home_0[i].Execute = 1;
				if (MC_Home_0[i].Done == 1 || MC_Home_0[i].CommandAborted == 1)	/*ɻж*/
				{
					MC_Home_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				if (MC_Home_0[i].Error == 1)									/**/
				{
					gMultiAxis[i].alarm.errorNumber = MC_Home_0[i].ErrorID;		/*湦ܿ*/
					MC_Home_0[i].Execute = 0;									/*ܿ鸴λ λܿ*/
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Switch controller on */
			case STEP_INIT_POWER_ON:											/*ѡǷִһ ϵpoweron ǵȴ*/
				/*Excute PLCOpen Function*/
				MC_Power_0[i].Enable = 1;
				if (MC_Power_0[i].Status == 1)
				{
					step[i] = STEP_COMMAND;
				}
				if (MC_Power_0[i].Error == 1)
				{
					gMultiAxis[i].alarm.errorNumber = MC_Power_0[i].ErrorID;
					MC_Power_0[i].Enable = 0;
					step[i] = STEP_ERROR_HANDLE;
				}	
				break;
			/* Init complete,Wait for command*/
			case STEP_COMMAND:													/*ȴ*/			
				/*********Command*********/
				gMultiAxis[i].cmd.errorAcknowledge = 0;
				
				if (gMultiAxis[i].cmd.ctrlOff == 1)
				{
					gMultiAxis[i].cmd.ctrlOff = 0;
					step[i] = STEP_SWITCH_OFF;
				}
				else if (gMultiAxis[i].cmd.ctrlOn == 1)
				{
					gMultiAxis[i].cmd.ctrlOn = 0;
					step[i] = STEP_SWITCH_ON;
				}
				else if (gMultiAxis[i].cmd.stop == 1)
				{
					gMultiAxis[i].cmd.stop = 0;
					step[i] = STEP_STOP_MOVE;
				}
				else if (gMultiAxis[i].cmd.posMove == 1)
				{
					gMultiAxis[i].cmd.posMove = 0;
					step[i] = STEP_POS_MOVE;
				}
				else if (gMultiAxis[i].cmd.negMove == 1)
				{
					gMultiAxis[i].cmd.negMove = 0;
					step[i] = STEP_NEG_MOVE;
				}
				else if (gMultiAxis[i].cmd.absMove == 1) 
				{
					gMultiAxis[i].cmd.absMove = 0;
					step[i] = STEP_ABS_MOVE;
				}
				else if (gMultiAxis[i].cmd.relMove == 1)
				{
					gMultiAxis[i].cmd.relMove = 0;
					step[i] = STEP_REL_MOVE;
				}
				else if (gMultiAxis[i].cmd.home == 1)
				{
					gMultiAxis[i].cmd.home = 0;   
					step[i] = STEP_HOME;   
				}
				else if (gMultiAxis[i].cmd.triggerStop == 1)
				{
					gMultiAxis[i].cmd.triggerStop = 0;
					step[i] = STEP_TRIGGER_STOP;
				}
				else if (gMultiAxis[i].cmd.camStart == 1)
				{
					gMultiAxis[i].cmd.camStart = 0;
					step[i] = STEP_CAM_START;
				}
				
				break;
			/* Switch controller off */
			case STEP_SWITCH_OFF:
				MC_Power_0[i].Enable = 0;
       
				if (MC_Power_0[i].Status == 0)
				{
					step[i] = STEP_COMMAND;
				}
				if (MC_Power_0[i].Error == 1 )
				{
					MC_Power_0[i].Enable = 0;
					gMultiAxis[i].alarm.errorNumber = MC_Power_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_SWITCH_OFF;
					step[i] = STEP_ERROR_HANDLE;
				}			
				break;
			/* Switch controller on */
			case STEP_SWITCH_ON:
				
				MC_Power_0[i].Enable = 1;
				if (MC_Power_0[i].Status == 1)
				{
					step[i] = STEP_COMMAND;
				}			
				if (MC_Power_0[i].Error == 1 )
				{
					MC_Power_0[i].Enable = 0;
					gMultiAxis[i].alarm.errorNumber = MC_Power_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_SWITCH_ON;
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Start homing procedure */
			case STEP_HOME:
				
				MC_Home_0[i].Position = gMultiAxis[i].para.homePosition;
				MC_Home_0[i].HomingMode = gMultiAxis[i].para.homeMode;
				MC_Home_0[i].Execute = 1;
				
				/*жϴ*/
				if (gMultiAxis[i].cmd.stop == 1 || gMultiAxis[i].cmd.ctrlOff == 1)
				{
					MC_Home_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_Home_0[i].Done == 1 || MC_Home_0[i].CommandAborted == 1)
				{
					MC_Home_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_Home_0[i].Error == 1 )
				{
					MC_Home_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_Home_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_HOME;
				
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Start movement in positive direction */
			case STEP_POS_MOVE:
				/*ֵ*/
				MC_MoveVelocity_0[i].Velocity 		= gMultiAxis[i].para.velocity;
				MC_MoveVelocity_0[i].Acceleration 	= gMultiAxis[i].para.acceleration;
				MC_MoveVelocity_0[i].Deceleration 	= gMultiAxis[i].para.deceleration;
				MC_MoveVelocity_0[i].Direction 		= mcPOSITIVE_DIR;
				/*ùܿ*/
				MC_MoveVelocity_0[i].Execute = 1;
				
				/*жϴ*/
				if (gMultiAxis[i].cmd.stop == 1 || gMultiAxis[i].cmd.ctrlOff == 1)
				{
					MC_MoveVelocity_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveVelocity_0[i].InVelocity == 1 || MC_MoveVelocity_0[i].CommandAborted == 1)
				{
					MC_MoveVelocity_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveVelocity_0[i].Error == 1 )
				{
					MC_MoveVelocity_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_MoveVelocity_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_POS_MOVE;
				
					step[i] = STEP_ERROR_HANDLE;
				}
				
				break;
			
			/* Start movement in negative direction */
			case STEP_NEG_MOVE:
				/*ֵ*/
				MC_MoveVelocity_0[i].Velocity = gMultiAxis[i].para.velocity;
				MC_MoveVelocity_0[i].Acceleration = gMultiAxis[i].para.acceleration;
				MC_MoveVelocity_0[i].Deceleration = gMultiAxis[i].para.deceleration;
				MC_MoveVelocity_0[i].Direction = mcNEGATIVE_DIR;
				/*ùܿ*/
				MC_MoveVelocity_0[i].Execute = 1;
				/*жϴ*/
				if (gMultiAxis[i].cmd.stop == 1 || gMultiAxis[i].cmd.ctrlOff == 1)
				{
					MC_MoveVelocity_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveVelocity_0[i].InVelocity == 1 || MC_MoveVelocity_0[i].CommandAborted == 1)
				{
					MC_MoveVelocity_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveVelocity_0[i].Error == 1 )
				{
					MC_MoveVelocity_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_MoveVelocity_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_NEG_MOVE;
				
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Start abolute movement */
			case STEP_ABS_MOVE:
				/*ֵ*/
				MC_MoveAbsolute_0[i].Position = gMultiAxis[i].para.absPosition;
				MC_MoveAbsolute_0[i].Velocity = gMultiAxis[i].para.velocity;
				MC_MoveAbsolute_0[i].Acceleration = gMultiAxis[i].para.acceleration;
				MC_MoveAbsolute_0[i].Deceleration = gMultiAxis[i].para.deceleration;
				MC_MoveAbsolute_0[i].Direction = mcSHORTEST_WAY;
				/*ùܿ*/
				MC_MoveAbsolute_0[i].Execute = 1;
				/*жϴ*/
				if (gMultiAxis[i].cmd.stop == 1 || gMultiAxis[i].cmd.ctrlOff == 1)
				{
					MC_Home_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveAbsolute_0[i].Done == 1 || MC_MoveAbsolute_0[i].CommandAborted == 1)
				{
					MC_MoveAbsolute_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveAbsolute_0[i].Error == 1 )
				{
					MC_MoveAbsolute_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_MoveAbsolute_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_ABS_MOVE;
				
					step[i] = STEP_ERROR_HANDLE;
				}
				
				break;
			
			/* Start relative movement */
			case STEP_REL_MOVE:
				/*ֵ*/
				MC_MoveAdditive_0[i].Distance = gMultiAxis[i].para.relPosition;
				MC_MoveAdditive_0[i].Velocity = gMultiAxis[i].para.velocity;
				MC_MoveAdditive_0[i].Acceleration = gMultiAxis[i].para.acceleration;
				MC_MoveAdditive_0[i].Deceleration = gMultiAxis[i].para.deceleration;
				/*ùܿ*/
				MC_MoveAdditive_0[i].Execute = 1;
				/*жϴ*/
				if (gMultiAxis[i].cmd.stop == 1 || gMultiAxis[i].cmd.ctrlOff == 1)
				{
					MC_Home_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveAdditive_0[i].Done == 1 || MC_MoveAdditive_0[i].CommandAborted == 1)
				{
					MC_MoveAdditive_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveAdditive_0[i].Error == 1 )
				{
					MC_MoveAdditive_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_MoveAdditive_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_REL_MOVE;
				
					step[i] = STEP_ERROR_HANDLE;
				}
				
				break;
			
			/* Stop movement */
			case STEP_STOP_MOVE:
				/*ֵ*/
				MC_Stop_0[i].Deceleration = gMultiAxis[i].para.stopDeceleration;
				MC_Stop_0[i].Execute = 1;
				/*жϴ*/
				if (gMultiAxis[i].cmd.ctrlOff == 1)
				{
					MC_Home_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_Stop_0[i].Done == 1 || MC_Stop_0[i].CommandAborted == 1)
				{
					MC_Stop_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_Stop_0[i].Error == 1 )
				{
					MC_Stop_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_Stop_0[i].ErrorID;
				
					step[i] = STEP_ERROR_HANDLE;
				}
				
				break;
			
			case STEP_TRIGGER_STOP:
				/*ֵ*/
				MC_BR_MoveVelocityTriggStop_0[i].Velocity = gMultiAxis[i].para.homeSpeed;
				MC_BR_MoveVelocityTriggStop_0[i].Acceleration = gMultiAxis[i].para.homeAcce;
				MC_BR_MoveVelocityTriggStop_0[i].Deceleration = gMultiAxis[i].para.homeAcce;
				MC_BR_MoveVelocityTriggStop_0[i].Direction = mcPOSITIVE_DIR;
				
				MC_BR_MoveVelocityTriggStop_0[i].TriggerInput.InputSource = ncTRIGGER1;
				MC_BR_MoveVelocityTriggStop_0[i].TriggerInput.Edge = ncP_EDGE;
				MC_BR_MoveVelocityTriggStop_0[i].TriggerDistance = gMultiAxis[i].para.trigStopOffset;
				
				MC_BR_MoveVelocityTriggStop_0[i].Execute = 1;
				/*жϴ*/
				if (gMultiAxis[i].cmd.stop == 1 || gMultiAxis[i].cmd.ctrlOff == 1)
				{
					MC_BR_MoveVelocityTriggStop_0[i].Execute = 0;
					gMultiAxis[i].status.triggerStopReady = 0;
					step[i] = STEP_STOP_MOVE;
				}
				/*ܿɻж*/
				if (MC_BR_MoveVelocityTriggStop_0[i].Done == 1 || MC_BR_MoveVelocityTriggStop_0[i].CommandAborted == 1)
				{
					MC_BR_MoveVelocityTriggStop_0[i].Execute = 0;
					gMultiAxis[i].status.triggerStopReady = 1;
				
					step[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_BR_MoveVelocityTriggStop_0[i].Error == 1 )
				{
					MC_BR_MoveVelocityTriggStop_0[i].Execute = 0;
					gMultiAxis[i].status.triggerStopReady = 0;
					gMultiAxis[i].alarm.errorNumber = MC_BR_MoveVelocityTriggStop_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_TRIGGER_STOP;
				
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			case STEP_CAM_START:
				MC_BR_WriteParID_0[i].Execute 		= 1;
				MC_BR_WriteParID_0[i].ParID   		= ACP10PAR_CMD_AUT_START;
				MC_BR_WriteParID_0[i].DataAddress 	= (UDINT)&PARID_VALUE_CAM_START;
				MC_BR_WriteParID_0[i].DataType    	= ncPAR_TYP_UINT;
				
				if (1 == MC_BR_WriteParID_0[i].Done)
				{
					MC_BR_WriteParID_0[i].Execute = 0;
					step[i] = STEP_COMMAND;
				}
				else if (MC_BR_WriteParID_0[i].Error)
				{  
					MC_BR_WriteParID_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_BR_WriteParID_0[i].ErrorID;
					gMultiAxis[i].status.errorStep = STEP_CAM_START;
					step[i] = STEP_ERROR_HANDLE;
				}
				break;
			case STEP_ERROR_HANDLE:														/**/
				/*Estop then power off*/
				MC_Power_0[i].Enable = 0;												/*ͣʹ ԼҪ*/
				FunResetAxisCmd();														/*plcOpenܿ鼰ӿ*/
				
				/*ȴᱨȴplcopenôҪλΣʱplcopenźᱨһ*/
				if (MC_ReadAxisError_0[i].Valid == 1 && MC_ReadAxisError_0[i].AxisErrorID != 0)
				{
					gMultiAxis[i].alarm.errorNumber = MC_ReadAxisError_0[i].AxisErrorID;/*ȡ*/
					step[i] = STEP_ERROR_AXIS;											/*ᱨ*/
				}
				else
				{
					step[i] = STEP_ERROR_FUN;											/*plcOpenܿ*/
				}
				break;
			case STEP_ERROR_FUN:														
				if (gMultiAxis[i].cmd.errorAcknowledge == 1)							/*plcOpenܿ*/
				{
					gMultiAxis[i].cmd.errorAcknowledge = 0;
					gMultiAxis[i].alarm.errorNumber = 0;
					gMultiAxis[i].status.errorStep = 0;
					/* reset axis if it is in axis state ErrorStop */
					if (MC_ReadStatus_0[i].Errorstop == 1 && MC_ReadStatus_0[i].Valid == 1)
					{
						step[i] = STEP_ERROR_RESET;
					}
					else
					{
						step[i] = STEP_INIT_NET_INIT;
					}
				}
				break;
			case STEP_ERROR_AXIS:														/*ᱨ*/
				/*ȡ*/
				if (MC_ReadAxisError_0[i].Valid == 1 && MC_ReadAxisError_0[i].AxisErrorID != 0)
				{
					gMultiAxis[i].alarm.errorNumber = MC_ReadAxisError_0[i].AxisErrorID;/*ȡ*/
				}
				
				MC_ReadAxisError_0[i].Acknowledge = 0;
				if (gMultiAxis[i].cmd.errorAcknowledge == 1)
				{
					gMultiAxis[i].cmd.errorAcknowledge = 0;
					/* acknowledge axis error */
					if (MC_ReadAxisError_0[i].AxisErrorID != 0)
					{
						MC_ReadAxisError_0[i].Acknowledge = 1;
					}
				}
				if (MC_ReadAxisError_0[i].AxisErrorCount == 0)
				{
					gMultiAxis[i].alarm.errorNumber = 0;
					gMultiAxis[i].status.errorStep = 0;
					/* reset axis if it is in axis state ErrorStop */
					if ((MC_ReadStatus_0[i].Errorstop == 1) && (MC_ReadStatus_0[i].Valid == 1))
					{
						step[i] = STEP_ERROR_RESET;
					}
					else
					{
						step[i] = STEP_INIT_NET_INIT;
					}
				}
				break;			
			case STEP_ERROR_RESET:														/*PLCopenerror stop state ִֻmcResetλ*/
				
				MC_Reset_0[i].Execute = 1;

				if(MC_Reset_0[i].Done == 1)
				{
					MC_Reset_0[i].Execute = 0;
					step[i] = STEP_INIT_NET_INIT;
				}
				else if (MC_Reset_0[i].Error == 1)
				{
					MC_Reset_0[i].Execute = 0;
					gMultiAxis[i].alarm.errorNumber = MC_Reset_0[i].ErrorID;
					step[i] = STEP_ERROR_HANDLE;   
				}
				break;
		}
		/**************************************************************/
		/*****************Function Block Calls*************************/
		/**************************************************************/

		/************************** MC_POWER **************************/
		MC_Power_0[i].Axis = (UDINT)pAxisData;
		MC_Power(&MC_Power_0[i]);

		/************************** MC_POWER **************************/
		MC_Home_0[i].Axis = (UDINT)pAxisData;
		MC_Home(&MC_Home_0[i]);
		
		/*********************** MC_MoveVelocity **********************/
		MC_MoveVelocity_0[i].Axis = (UDINT)pAxisData;
		MC_MoveVelocity(&MC_MoveVelocity_0[i]);
		
		/*********************** MC_MoveAbsolute **********************/
		MC_MoveAbsolute_0[i].Axis = (UDINT)pAxisData;
		MC_MoveAbsolute(&MC_MoveAbsolute_0[i]);
		
		/*********************** MC_MoveAdditive **********************/
		MC_MoveAdditive_0[i].Axis = (UDINT)pAxisData;
		MC_MoveAdditive(&MC_MoveAdditive_0[i]);
		
		/*************************** MC_Stop **************************/
		MC_Stop_0[i].Axis = (UDINT)pAxisData;
		MC_Stop(&MC_Stop_0[i]);
		
		/***************** MC_BR_MoveVelocityTriggStop ****************/
		MC_BR_MoveVelocityTriggStop_0[i].Axis = (UDINT)pAxisData;
		MC_BR_MoveVelocityTriggStop(&MC_BR_MoveVelocityTriggStop_0[i]);
		
		/*************************** MC_Reset *************************/
		MC_Reset_0[i].Axis = (UDINT)pAxisData;
		MC_Reset(&MC_Reset_0[i]);
		
		/********************** MC_BR_InitAxisPar *********************/
		MC_BR_InitAxisPar_0[i].Axis = (UDINT)pAxisData;
		MC_BR_InitAxisPar(&MC_BR_InitAxisPar_0[i]);
		
		/********************** MC_BR_WriteParID *********************/
		MC_BR_WriteParID_0[i].Axis = (UDINT)pAxisData;
		MC_BR_WriteParID(&MC_BR_WriteParID_0[i]);
	}
}

void _EXIT ProgramExit(void)
{
	// Insert code here 

}

/*ܿӿڸλ plcOpenܿӿڸλ*/
void FunResetAxisCmd()
{
	memset(&gMultiAxis[i].cmd,0,sizeof(gMultiAxis[i].cmd));
				
	/* reset all FB execute inputs */
	MC_Power_0[i].Enable 			= 0;
	MC_Home_0[i].Execute 			= 0;
	MC_MoveVelocity_0[i].Execute 	= 0;
	MC_MoveAbsolute_0[i].Execute 	= 0;
	MC_MoveAdditive_0[i].Execute 	= 0;
	MC_Stop_0[i].Execute 			= 0;
	MC_Reset_0[i].Execute 			= 0;
	MC_BR_InitAxisPar_0[i].Execute 	= 0;
	MC_BR_MoveVelocityTriggStop_0[i].Execute = 0;
	MC_BR_WriteParID_0[0].Execute	= 0;
}
