
#include <bur/plctypes.h>

#ifdef _DEFAULT_INCLUDES
	#include <AsDefault.h>
#endif

#include "string.h"

void FunResetVAxisCmd();

#define	STEP_INIT_NET_INIT			10
#define	STEP_INIT_POWER_OFF			20
#define	STEP_INIT_GLOBAL_INIT		30
#define	STEP_INIT_HOMING_DIRECT		40
#define	STEP_COMMAND				50
#define	STEP_SWITCH_OFF				60
#define	STEP_SWITCH_ON				70
#define	STEP_STOP_MOVE				80
#define	STEP_POS_MOVE				90
#define	STEP_NEG_MOVE				100
#define	STEP_ABS_MOVE				130
#define	STEP_REL_MOVE				140
#define	STEP_HOME					150
#define	STEP_TRIGGER_STOP_HOME		160
#define	STEP_CAM_START				170
#define	STEP_NOT_USE				180

#define	STEP_ERROR_HANDLE			900			/*裬֮*/
#define	STEP_ERROR_FUN				910			/*裬֮*/
#define	STEP_ERROR_AXIS				920			/*裬֮*/
#define	STEP_ERROR_RESET			930			/*裬֮*/

void _INIT ProgramInit(void)
{
	initOK = 0;	
	for(i = 0; i < MULTI_VAXIS_NUM; i ++)
	{
		/******************************************ȡָ********************************/
		if(MULTI_VAXIS_NAME[i][0] != 0)
		{
			ncVStatus[i] = ncaccess(ncACP10MAN, (STRING*)MULTI_VAXIS_NAME[i], &vAxisObj[i]);
		}
		if ( (ncVStatus[i] != ncOK) && (ncVStatus[i] != 10600) )
		{
			/* The NC object pointer is invalid */
			gMultiVAxis[i].alarm.errorNumber = ncVStatus[i];
			strcpy(gMultiVAxis[i].alarm.errorText[0], "Error to access vax name in NC-Table");
			continue;
		}
		/*ָѾȫֱҲԴȫֱȡ*/
		
		/*˶ʼ*/
		gMultiVAxis[i].para.velocity		= 3000;
		gMultiVAxis[i].para.acceleration	= 5000;
		gMultiVAxis[i].para.deceleration	= 5000;
		gMultiVAxis[i].para.stopDeceleration= 10000;
		gMultiVAxis[i].para.absPosition		= 0;
		gMultiVAxis[i].para.relPosition		= 0;
		/*stepλ*/
		vAxisStep[i] = STEP_INIT_NET_INIT;
	}
	initOK = 1;	
}

void _CYCLIC ProgramCyclic(void)
{
	// Insert code here 
	if (initOK == 0) return;  //ʼ

	for (i = 0; i < MULTI_VAXIS_NUM; i++)
	{
		/* Get the pointer of NC manager structure */
		pVAxisData = (ACP10VAXIS_typ*)vAxisObj[i];
		if(pVAxisData == 0)	return;

		/****************Get axis status****************/
		gMultiVAxis[i].status.actVelocity = pVAxisData->monitor.v;
		gMultiVAxis[i].status.actPosition = pVAxisData->monitor.s;
		gMultiVAxis[i].status.moveMode	 = pVAxisData->move.mode;
		gMultiVAxis[i].status.ctrlReady	 = pVAxisData->controller.status;
		gMultiVAxis[i].status.homeReady	 = pVAxisData->move.homing.status.ok;
		gMultiVAxis[i].status.inPosition = pVAxisData->move.basis.status.in_pos;
		gMultiVAxis[i].status.step		 = vAxisStep[i];
		
		/****************Read axis error****************/
		MC_ReadAxisError_1[i].Axis = (UDINT)pVAxisData;
		MC_ReadAxisError_1[i].Enable = !MC_ReadAxisError_1[i].Error;
		MC_ReadAxisError_1[i].DataAddress = (UDINT)&(gMultiVAxis[i].alarm.errorText);
		MC_ReadAxisError_1[i].DataLength = sizeof(gMultiVAxis[i].alarm.errorText);
		strcpy((void*)&MC_ReadAxisError_1[i].DataObjectName,"acp10etxen");
		MC_ReadAxisError(&MC_ReadAxisError_1[i]);
		
		/*****************Read status******************/
		MC_ReadStatus_1[i].Axis = (UDINT)pVAxisData;
		MC_ReadStatus_1[i].Enable = !MC_ReadStatus_1[i].Error;
		MC_ReadStatus(&MC_ReadStatus_1[i]);
		if(MC_ReadStatus_1[i].ContinuousMotion == 1 || MC_ReadStatus_1[i].Disabled == 1 || MC_ReadStatus_1[i].DiscreteMotion == 1 || MC_ReadStatus_1[i].Errorstop == 1 
			|| MC_ReadStatus_1[i].Homing == 1 || MC_ReadStatus_1[i].StandStill == 1 || MC_ReadStatus_1[i].Stopping == 1 || MC_ReadStatus_1[i].SynchronizedMotion == 1)
		{
			vAxisStatusReady[i] = 1;
			/*Ӵ˲ԭǷиϵMC_ReadStatusóɹһСʱ״̬0ڴʱڵκplcOpenɱ*/
		}
		else
		{
			vAxisStatusReady[i] = 0;
		}
		/**************************************************************************************************/
		if (MC_ReadAxisError_1[i].AxisErrorCount > 0 && MC_ReadAxisError_1[i].Valid == 1 && vAxisStep[i] < STEP_ERROR_HANDLE)
		{
			vAxisStep[i] = STEP_ERROR_HANDLE;	/*ᱨֱת*/
		}
		/**********************************************************************************************************/
		
		/***State sequence for handling the NC Object***/
		switch (vAxisStep[i])
		{
			/* Wait until the network is initialized */
			case STEP_INIT_NET_INIT:											/*ȴʼ - һplcOpenҲҪ*/
				if (pVAxisData->network.init == ncTRUE && vAxisStatusReady[i] == 1)
				{
					vAxisStep[i] = STEP_INIT_POWER_OFF;
				}
				break;
			case STEP_INIT_POWER_OFF:											/*power off*/
				/*нӿλ*//*plcOpenִܿλ*/
				FunResetVAxisCmd();
				/*Excute PLCOpen Function*/
				MC_Power_1[i].Enable = 0;
				if (MC_Power_1[i].Status == 0)									/*ɻж CommandAborted ڴ˴*/
				{
					vAxisStep[i] = STEP_COMMAND;										/*Ҫת*//*STEP_INIT_GLOBAL_INIT*//**//*STEP_COMMAND*/
				}
				if (MC_Power_1[i].Error == 1)									/**/	
				{
					gMultiVAxis[i].alarm.errorNumber = MC_Power_1[i].ErrorID;	/*湦ܿ*/
					MC_Power_1[i].Enable = 0;									/*ܿ鸴λ λܿ*/
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Init complete,Wait for command*/
			case STEP_COMMAND:													/*ȴ*/			
				/*********Command*********/
				gMultiVAxis[i].cmd.errorAcknowledge = 0;
				
				if (gMultiVAxis[i].cmd.stop == 1)
				{
					gMultiVAxis[i].cmd.stop = 0;
					vAxisStep[i] = STEP_STOP_MOVE;
				}
				else if (gMultiVAxis[i].cmd.posMove == 1)
				{
					gMultiVAxis[i].cmd.posMove = 0;
					vAxisStep[i] = STEP_POS_MOVE;
				}
				else if (gMultiVAxis[i].cmd.negMove == 1)
				{
					gMultiVAxis[i].cmd.negMove = 0;
					vAxisStep[i] = STEP_NEG_MOVE;
				}
				else if (gMultiVAxis[i].cmd.absMove == 1) 
				{
					gMultiVAxis[i].cmd.absMove = 0;
					vAxisStep[i] = STEP_ABS_MOVE;
				}
				else if (gMultiVAxis[i].cmd.relMove == 1)
				{
					gMultiVAxis[i].cmd.relMove = 0;
					vAxisStep[i] = STEP_REL_MOVE;
				}
				else if (gMultiVAxis[i].cmd.home == 1)
				{
					gMultiVAxis[i].cmd.home = 0;   
					vAxisStep[i] = STEP_HOME;   
				}
				else if (gMultiVAxis[i].cmd.camStart == 1)
				{
					gMultiVAxis[i].cmd.camStart = 0;
					vAxisStep[i] = STEP_CAM_START;
				}
				
				break;
			/* Switch controller off */
			case STEP_SWITCH_OFF:
				MC_Power_1[i].Enable = 0;
       
				if (MC_Power_1[i].Status == 0)
				{
					vAxisStep[i] = STEP_COMMAND;
				}
				if (MC_Power_1[i].Error == 1 )
				{
					MC_Power_1[i].Enable = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_Power_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_SWITCH_OFF;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}			
				break;
			/* Switch controller on */
			case STEP_SWITCH_ON:
				
				MC_Power_1[i].Enable = 1;
				if (MC_Power_1[i].Status == 1)
				{
					vAxisStep[i] = STEP_COMMAND;
				}			
				if (MC_Power_1[i].Error == 1 )
				{
					MC_Power_1[i].Enable = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_Power_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_SWITCH_ON;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			
			/* Start homing procedure */
			case STEP_HOME:
				/*ֵ*/
				MC_Home_1[i].Position = gMultiVAxis[i].para.homePosition;
				MC_Home_1[i].HomingMode = gMultiVAxis[i].para.homeMode;
				MC_Home_1[i].Execute = 1;
				/*жϴ*/
				if (gMultiVAxis[i].cmd.stop == 1)
				{
					MC_Home_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_Home_1[i].Done == 1 || MC_Home_1[i].CommandAborted == 1)
				{
					MC_Home_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_Home_1[i].Error == 1 )
				{
					MC_Home_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_Home_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_HOME;
				
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Start movement in positive direction */
			case STEP_POS_MOVE:
				/*ֵ*/
				MC_MoveVelocity_1[i].Velocity = gMultiVAxis[i].para.velocity;
				MC_MoveVelocity_1[i].Acceleration = gMultiVAxis[i].para.acceleration;
				MC_MoveVelocity_1[i].Deceleration = gMultiVAxis[i].para.deceleration;
				MC_MoveVelocity_1[i].Direction = mcPOSITIVE_DIR;
				/*ùܿ*/
				MC_MoveVelocity_1[i].Execute = 1;
				/*жϴ*/
				if (gMultiVAxis[i].cmd.stop == 1)
				{
					MC_MoveVelocity_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveVelocity_1[i].InVelocity == 1 || MC_MoveVelocity_1[i].CommandAborted == 1)
				{
					MC_MoveVelocity_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveVelocity_1[i].Error == 1 )
				{
					MC_MoveVelocity_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_MoveVelocity_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_POS_MOVE;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Start movement in negative direction */
			case STEP_NEG_MOVE:
				/*ֵ*/
				MC_MoveVelocity_1[i].Velocity = gMultiVAxis[i].para.velocity;
				MC_MoveVelocity_1[i].Acceleration = gMultiVAxis[i].para.acceleration;
				MC_MoveVelocity_1[i].Deceleration = gMultiVAxis[i].para.deceleration;
				MC_MoveVelocity_1[i].Direction = mcNEGATIVE_DIR;
				/*ùܿ*/
				MC_MoveVelocity_1[i].Execute = 1;
				/*жϴ*/
				if (gMultiVAxis[i].cmd.stop == 1)
				{
					MC_MoveVelocity_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveVelocity_1[i].InVelocity == 1 || MC_MoveVelocity_1[i].CommandAborted == 1)
				{
					MC_MoveVelocity_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveVelocity_1[i].Error == 1 )
				{
					MC_MoveVelocity_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_MoveVelocity_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_NEG_MOVE;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Start abolute movement */
			case STEP_ABS_MOVE:
				/*ֵ*/
				MC_MoveAbsolute_1[i].Position = gMultiVAxis[i].para.absPosition;
				MC_MoveAbsolute_1[i].Velocity = gMultiVAxis[i].para.velocity;
				MC_MoveAbsolute_1[i].Acceleration = gMultiVAxis[i].para.acceleration;
				MC_MoveAbsolute_1[i].Deceleration = gMultiVAxis[i].para.deceleration;
				MC_MoveAbsolute_1[i].Direction = mcSHORTEST_WAY;
				/*ùܿ*/
				MC_MoveAbsolute_1[i].Execute = 1;
				/*жϴ*/
				if (gMultiVAxis[i].cmd.stop == 1)
				{
					MC_MoveAbsolute_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveAbsolute_1[i].Done == 1 || MC_MoveAbsolute_1[i].CommandAborted == 1)
				{
					MC_MoveAbsolute_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveAbsolute_1[i].Error == 1 )
				{
					MC_MoveAbsolute_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_MoveAbsolute_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_ABS_MOVE;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			
			/* Start relative movement */
			case STEP_REL_MOVE:
				/*ֵ*/
				MC_MoveAdditive_1[i].Distance = gMultiVAxis[i].para.relPosition;
				MC_MoveAdditive_1[i].Velocity = gMultiVAxis[i].para.velocity;
				MC_MoveAdditive_1[i].Acceleration = gMultiVAxis[i].para.acceleration;
				MC_MoveAdditive_1[i].Deceleration = gMultiVAxis[i].para.deceleration;
				/*ùܿ*/
				MC_MoveAdditive_1[i].Execute = 1;
				/*жϴ*/
				if (gMultiVAxis[i].cmd.stop == 1)
				{
					MC_MoveAdditive_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿɻж*/
				if (MC_MoveAdditive_1[i].Done == 1 || MC_MoveAdditive_1[i].CommandAborted == 1)
				{
					MC_MoveAdditive_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_MoveAdditive_1[i].Error == 1 )
				{
					MC_MoveAdditive_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_MoveAdditive_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_REL_MOVE;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* Stop movement */
			case STEP_STOP_MOVE:
				MC_Stop_1[i].Deceleration = gMultiVAxis[i].para.stopDeceleration;
				MC_Stop_1[i].Execute = 1;
				/*ܿɻж*/
				if (MC_Stop_1[i].Done == 1 || MC_Stop_1[i].CommandAborted == 1)
				{
					MC_Stop_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				/*ܿó*/
				if (MC_Stop_1[i].Error == 1 )
				{
					MC_Stop_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_Stop_1[i].ErrorID;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			/* vaxis set cam start command */
			case STEP_CAM_START:
				MC_BR_WriteParID_1[i].Execute 		= 1;
				MC_BR_WriteParID_1[i].ParID   		= ACP10PAR_CMD_AUT_START_VAX1;
				MC_BR_WriteParID_1[i].DataAddress 	= (UDINT)&PARID_VALUE_CAM_START;
				MC_BR_WriteParID_1[i].DataType    	= ncPAR_TYP_UINT;
				
				if (1 == MC_BR_WriteParID_1[i].Done)
				{
					MC_BR_WriteParID_1[i].Execute = 0;
					vAxisStep[i] = STEP_COMMAND;
				}
				else if (MC_BR_WriteParID_1[i].Error)
				{  
					MC_BR_WriteParID_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_BR_WriteParID_1[i].ErrorID;
					gMultiVAxis[i].status.errorStep = STEP_CAM_START;
					vAxisStep[i] = STEP_ERROR_HANDLE;
				}
				break;
			case STEP_ERROR_HANDLE:														/**/
				/*Estop then power off*/
				MC_Power_1[i].Enable = 0;												/*ͣʹ*/
				FunResetVAxisCmd();														/*plcOpenܿ鼰ӿ*/
				
				/*ȴᱨȴplcopenôҪλΣʱplcopenźᱨһ*/
				if (MC_ReadAxisError_1[i].Valid == 1 && MC_ReadAxisError_1[i].AxisErrorID != 0)
				{
					gMultiVAxis[i].alarm.errorNumber = MC_ReadAxisError_1[i].AxisErrorID;/*ȡ*/
					vAxisStep[i] = STEP_ERROR_AXIS;											/*ᱨ*/
				}
				else
				{
					vAxisStep[i] = STEP_ERROR_FUN;											/*plcOpenܿ*/
				}
				break;
			case STEP_ERROR_FUN:														
				if (gMultiVAxis[i].cmd.errorAcknowledge == 1)							/*plcOpenܿ*/
				{
					gMultiVAxis[i].cmd.errorAcknowledge = 0;
					gMultiVAxis[i].alarm.errorNumber = 0;
					gMultiVAxis[i].status.errorStep = 0;
					/* reset axis if it is in axis state ErrorStop */
					if (MC_ReadStatus_1[i].Errorstop == 1 && MC_ReadStatus_1[i].Valid == 1)
					{
						vAxisStep[i] = STEP_ERROR_RESET;
					}
					else
					{
						vAxisStep[i] = STEP_INIT_NET_INIT;
					}
				}
				break;
			case STEP_ERROR_AXIS:														/*ᱨ*/
				/*ȡ*/
				if (MC_ReadAxisError_1[i].Valid == 1 && MC_ReadAxisError_1[i].AxisErrorID != 0)
				{
					gMultiVAxis[i].alarm.errorNumber = MC_ReadAxisError_1[i].AxisErrorID;/*ȡ*/
				}
				
				MC_ReadAxisError_1[i].Acknowledge = 0;
				if (gMultiVAxis[i].cmd.errorAcknowledge == 1)
				{
					gMultiVAxis[i].cmd.errorAcknowledge = 0;
					/* acknowledge axis error */
					if (MC_ReadAxisError_1[i].AxisErrorID != 0)
					{
						MC_ReadAxisError_1[i].Acknowledge = 1;
					}
				}
				if (MC_ReadAxisError_1[i].AxisErrorCount == 0)
				{
					gMultiVAxis[i].alarm.errorNumber = 0;
					gMultiVAxis[i].status.errorStep = 0;
					/* reset axis if it is in axis state ErrorStop */
					if ((MC_ReadStatus_1[i].Errorstop == 1) && (MC_ReadStatus_1[i].Valid == 1))
					{
						vAxisStep[i] = STEP_ERROR_RESET;
					}
					else
					{
						vAxisStep[i] = STEP_INIT_NET_INIT;
					}
				}
				break;			
			case STEP_ERROR_RESET:														/*PLCopenerror stop state ִֻmcResetλ*/
				
				MC_Reset_1[i].Execute = 1;

				if(MC_Reset_1[i].Done == 1)
				{
					MC_Reset_1[i].Execute = 0;
					vAxisStep[i] = STEP_INIT_NET_INIT;
				}
				else if (MC_Reset_1[i].Error == 1)
				{
					MC_Reset_1[i].Execute = 0;
					gMultiVAxis[i].alarm.errorNumber = MC_Reset_1[i].ErrorID;
					vAxisStep[i] = STEP_ERROR_HANDLE;   
				}
				break;
		}
		/**************************************************************/
		/*****************Function Block Calls*************************/
		/**************************************************************/

		/************************** MC_POWER **************************/
		MC_Power_1[i].Axis = (UDINT)pVAxisData;
		MC_Power(&MC_Power_1[i]);

		/************************** MC_POWER **************************/
		MC_Home_1[i].Axis = (UDINT)pVAxisData;
		MC_Home(&MC_Home_1[i]);
		
		/*********************** MC_MoveVelocity **********************/
		MC_MoveVelocity_1[i].Axis = (UDINT)pVAxisData;
		MC_MoveVelocity(&MC_MoveVelocity_1[i]);
		
		/*********************** MC_MoveAbsolute **********************/
		MC_MoveAbsolute_1[i].Axis = (UDINT)pVAxisData;
		MC_MoveAbsolute(&MC_MoveAbsolute_1[i]);
		
		/*********************** MC_MoveAdditive **********************/
		MC_MoveAdditive_1[i].Axis = (UDINT)pVAxisData;
		MC_MoveAdditive(&MC_MoveAdditive_1[i]);
		
		/*************************** MC_Stop **************************/
		MC_Stop_1[i].Axis = (UDINT)pVAxisData;
		MC_Stop(&MC_Stop_1[i]);
		
		/*************************** MC_Reset *************************/
		MC_Reset_1[i].Axis = (UDINT)pVAxisData;
		MC_Reset(&MC_Reset_1[i]);
		
		/********************** MC_BR_WriteParID *********************/
		MC_BR_WriteParID_1[i].Axis = (UDINT)pVAxisData;
		MC_BR_WriteParID(&MC_BR_WriteParID_1[i]);
	}
}

void _EXIT ProgramExit(void)
{
	// Insert code here 

}

/*ܿӿڸλ plcOpenܿӿڸλ*/
void FunResetVAxisCmd()
{
	memset(&gMultiVAxis[i].cmd,0,sizeof(gMultiVAxis[i].cmd));
				
	/* reset all FB execute inputs */
	MC_Power_1[i].Enable 			= 0;
	MC_Home_1[i].Execute 			= 0;
	MC_MoveVelocity_1[i].Execute 	= 0;
	MC_MoveAbsolute_1[i].Execute 	= 0;
	MC_MoveAdditive_1[i].Execute 	= 0;
	MC_Stop_1[i].Execute 			= 0;
	MC_Reset_1[i].Execute 			= 0;
	MC_BR_WriteParID_1[0].Execute	= 0;
}
